DECLARE SUB bin2str ()
'-- absolute.bas ----------------------------------------------- >>fst'01<< -
' - Demo, wie Maschinencode aus Assembler-Quelltext erzeugt und
'   in Basic eingebunden werden kann.
' - Quelldatei ist ein Assembler-Textdatei, erzeugt werden eine
'   * Binaerdatei, die direkt in einen String (BIN$) eingelesen wird
'     (gut zum Testen) und ein
'   * BASIC-Quelltext, dessen Stringzuweisung (MC$ = ...) in eigenen
'     Programmen verwendet werden kann (statt Benutzung der Binaerdatei).
'     Diese Datei hat die Endung ba$.
' - Als Assembler wird der Wolfware-Assembler verwendet. Er ist Freeware
'   und erzeugt direkt ausfuehrbare com-Dateien. Download des gesamten
'   Programmpakets: http://user.mc.net/~warp/software.html
' - Der Editor ist ein Freeware-Programm aus Deutschland.
' - PUBLIC DOMAIN
'-- V 20011008 ------------------------------ http://home.arcor.de/steini63 -

DIM SHARED DATEI$, BIN$

'--- Dateinamen festlegen:
'hier gewuenschten Dateinamen eingeben; aus DATEI.ASM
'werden DATEI.BIN und DATEI.BA$ erzeugt.
'DATEI$ = "ein_x"               '<-- Beispiel 1
DATEI$ = "rechne"              '<-- Beispiel 2
'DATEI$ = "????????"            '<-- hier ein neues Projekt eintragen
DateiASM$ = DATEI$ + ".asm"
DateiBIN$ = DATEI$ + ".bin"

'--- Editor mit ASM-Datei starten:
SHELL "e.exe " + DateiASM$

'--- ASM-Datei assemblieren (Dateiendung .bin):
SHELL "wasm " + DateiASM$ + " " + DateiBIN$

'--- Maschinencode-Binaerdatei in String einlesen:
OPEN DateiBIN$ FOR BINARY AS #1
BIN$ = INPUT$(LOF(1), #1)

'--- Kontrolle, ob String vollstaendig eingelesen:
IF LEN(BIN$) <> LOF(1) THEN
 PRINT : PRINT "ABBRUCH:  Binaerdatei und String ungleich lang!"
 PRINT : BEEP
 END
END IF

CLOSE 1#   'Binaerdatei schliessen

'--- Hinweise anzeigen:
COLOR 14
PRINT USING "##### Byte(s) gelesen        "; LEN(BIN$);
COLOR 3
PRINT " CALL ABSOLUTE - Test  fuer QBasic      >>fst'01<<"
COLOR 14

'-- BASIC-Quelltext mit Maschinencode-Stringzuweisung erzeugen
CALL bin2str

'-- Abfrage, ob Code in BIN$ gestartet werden soll:
PRINT "Maschinencode starten?                [J] = Ja            [andere Taste] = Nein";
COLOR 7
T$ = UCASE$(INPUT$(1))
PRINT

'--- Speicher-Segment und -Offset von BIN$ festlegen:
DEF SEG = VARSEG(BIN$)
Offset% = SADD(BIN$)

'--- Maschinencode (Beispiel 1) nach Abfrage ueber CALL ABSOLUTE starten:
IF T$ = "J" AND DATEI$ = "ein_x" THEN
 CALL ABSOLUTE(Offset%)
 'Fehler "Unterprogramm nicht definiert" ? -> QuickBasic mit /L starten!
END IF

'--- ... oder Beispiel 2 starten:
IF T$ = "J" AND DATEI$ = "rechne" THEN  'Abfrage, ob gestartet werden soll

 Var1% = 2                              'Variable 1 belegen
 Var2% = 4                              'Variable 2 belegen
 PRINT                                  'Werte anzeigen ...
 PRINT USING "Vor  CALL INTERRUPT:  Variable1 =##  Variable2 =##"; Var1%; Var2%

 'Es wird ernst, wir starten das Maschinenprogramm:
 CALL ABSOLUTE(Var1%, Var2%, Offset%)
 'Fehler "Unterprogramm nicht definiert" ? -> QuickBasic mit /L starten!

 'Jetzt muessten die Variablen neue Werte haben:
 PRINT USING "Nach CALL INTERRUPT:  Variable1 =##  Variable2 =##"; Var1%; Var2%
END IF

SUB bin2str
'erzeugt eine BASIC-Quelldatei, in die eine Stringzuweisung (MC$ = ...)
'geschrieben wird. Der String MC$ enthaelt denselben Maschinencode, wie
'der String BIN$ und die vom Assembler erzeugte Binaerdatei. MC$ kann in
'eigene Quelltexte kopiert werden um mit CALL ABSOLUTE gestartet zu werden.

ZeilenL% = 253                         'Zeilenlaenge (kann angepasst werden)
ZeilenU% = ZeilenL% - 2                'Zeilenumbruch
DateiBA$ = UCASE$(DATEI$) + ".BA$"     'Dateiname der BASIC-Zieldatei

OPEN DateiBA$ FOR OUTPUT AS #1         'Zieldatei oeffnen
Laenge% = LEN(BIN$)                    'Laenge des Strings speichern
PRINT #1, "MC$ = ";                    'Zeilenbeginn

FOR i% = 1 TO Laenge%                  'Alle Zeichen im String lesen

 Byte$ = MID$(BIN$, i%, 1)             'ein Byte aus Binaerstring lesen
 ASCII% = ASC(Byte$)                   'ASCII-Wert bestimmen

 LOCATE , 1                            'kleine
 PRINT USING "##### Byte(s)"; i%;      'Fortschrittsanzeige

 SELECT CASE ASCII%                    'auf Spezialzeichen pruefen

 CASE 0, 1, 2, 10, 13, 26, 34          'wenn ein Spezialzeichen vorliegt
 
  IF ASCII% < 10 THEN                  'wenn eine Ziffer ...
   LS% = 9                             'Platzverbrauch fuer den String
   SZ$ = "CHR$(#)"                     'Format fuer PRINT USING
  ELSE                                 'wenn zwei Ziffern ...
   LS% = 10                            'Platzverbrauch fuer den String
   SZ$ = "CHR$(##)"                    'Format fuer PRINT USING
  END IF
 
  IF LOF(1#) > ZeilenU% - LS% THEN     'wenn es nicht mehr in die Zeile passt
  
    IF V% = 2 THEN PRINT #1, CHR$(34); 'wenn zuvor normales Zeichen:
                                       'schliessendes Anfuehrungszeichen
    ZeilenU% = LOF(1#) + ZeilenL%      'Position naechster Zeilenumbruch
  
    PRINT #1,                          'Zeilenumbruch
    PRINT #1, "MC$ = MC$";             'neuer Zeilenbeginn

   ELSE                                'wenn noch Platz in der Zeile
  
    IF V% = 2 THEN PRINT #1, CHR$(34); 'Anfuehrungszeichen

  END IF                               '

  IF V% THEN PRINT #1, " + ";          ' + ,wenn nicht erstes Zeichen

  PRINT #1, USING SZ$; ASCII%;         'Zeichen per CHR$ ausgeben

  V% = 1                               'Zeichentyp speichern

 CASE ELSE                             'wenn kein Spezialzeichen vorliegt
   
  'Korrektur, wenn " + " ergaenzt werden muss:
  IF V% = 1 THEN ZeilenU2% = ZeilenU% - 4 ELSE ZeilenU2% = ZeilenU%

  IF LOF(1#) > ZeilenU2% THEN          'wenn es nicht mehr in die Zeile passt
  
   IF V% = 2 THEN PRINT #1, CHR$(34);  'wenn zuvor ein normales Zeichen:
                                       'schliessende Anfuehrungszeichen
   ZeilenU% = LOF(1#) + ZeilenL%       'Position neuer Zeilenumbruch
  
   PRINT #1,                           'Zeilenumbruch
   PRINT #1, "MC$ = MC$ + "; CHR$(34);  'neuer Zeilenbeginn

  ELSE                                 'wenn noch Platz in der Zeile
  
   IF V% = 0 THEN PRINT #1, CHR$(34);  'wenn allererstes Zeichen:
                                       'fuehrende Anfuehrungszeichen
   IF V% = 1 THEN PRINT #1, " + "; CHR$(34);  'wenn zuvor Spezialzeichen:
                                              ' + ergaenzen
  END IF
 
  PRINT #1, Byte$;                     'Zeichen ausgeben
 
  V% = 2                               'Zeichentyp speichern

 END SELECT

NEXT                                   'naechstes Zeichen bearbeiten

IF V% = 2 THEN PRINT #1, CHR$(34)

PRINT #1, : PRINT #1,
PRINT #1, "'-- Maschinencode-String erzeugt mit absolute.bas -------------- >>fst'01<< -"
PRINT #1, "' - Unveraenderter String MC$ kann mit CALL ABSOLUTE verwendet werden"
PRINT #1, "' - Quelldatei: "; DateiBIN$; "  Konvertiert: "; DATE$; "  "; TIME$
PRINT #1, "' - Zur Kontrolle der Konvertierung bitte mit [F5] starten!"
PRINT #1, "'-- V 20011008 ------------------------------ http://home.arcor.de/steini63 -"
PRINT #1,
PRINT #1, "DateiL% ="; Laenge%
PRINT #1, "PRINT USING ";
PRINT #1, CHR$(34);
PRINT #1, "Codelaenge Binaerdatei =###### Byte;  Codelaenge String =###### Byte   ";
PRINT #1, CHR$(34);
PRINT #1, "; DateiL%; LEN(MC$);"
PRINT #1, "IF DateiL% = LEN(MC$) THEN PRINT ";
PRINT #1, CHR$(34);
PRINT #1, "    O.K.";
PRINT #1, CHR$(34);
PRINT #1, " ELSE PRINT ";
PRINT #1, CHR$(34);
PRINT #1, "FEHLER !";
PRINT #1, CHR$(34);
PRINT #1, ": BEEP"
PRINT #1, "END"

CLOSE #1
PRINT " Maschinencode-String in Datei  "; DateiBA$; "  geschrieben."

END SUB

