;-- rechne.asm ------------------------------------------------- >>fst'01<< -
; - Beispiel zur Verwendung mit absolute.bas
; - Veraendert zwei vom BASIC Programm uebergebene Integer-Variablen.
; - Aufruf in BASIC: CALL ABSOLUTE (Var1%, Var2%, Offset%)
; - Hinweis: Bei drei uebergebenen Variablen waere
;   Var1 bei [bp+10], Var2 bei [bp+8], Var3 bei [bp+6].
;-- V 20011008 ------------------------------ http://home.arcor.de/steini63 -

;-- BP auf Spitze des Stacks zeigen lassen. ---------------------------------
;Leider kann man mit dem Stack-Pointer (SP) keine Speicher-Adressierung
;durchfuehren (z.B. [SP+2]). Deshalb muessen wir den Stack-Basepointer (BP)
;auf eine definierte Stelle setzen, naemlich die aktuelle Spitze des Stacks. 
;Anschliessend liegen alle von BASIC uebergebenen Parameter UEBER dem BP; 
;alles was nach "MOV BP,SP" auf des Stack geht DARUNTER (der Stack waechst 
;von oben nach unten!). 

	push	bp		;Stack-Basispointer retten
	mov	bp,sp		;BP neu ist die aktuelle Spitze des Stacks

;-- Register laden mit den Werten der uebergebenen Variablen ----------------
;Auf dem Stack liegen die Speicheradressen (Offsets) der von BASIC ueber-
;gebenen Variablen jetzt ab BP+6 aufwaerts, beginnend mit der letzten 
;(rechtsbuendig neben Offset%) stehenden. Bei BP+4/BP+2 befinden sich 
;Segment/Offset der Ruecksprungadresse zu BASIC, bei BP+0 der gePUSHte Wert 
;des originalen BP.

	mov	bx,[bp+8]       ;Speicheradresse des ersten Variable nach BX
	mov	ax,[bx]		;Wert der Variable aus Speicher nach AX holen
	mov	bx,[bp+6]	;Speicheradresse der zweiten Variable nach BX
	mov	cx,[bx]		;Wert der Variable nach CX holen

;-- Zwei nutzlose Berechnungen zu Demonstrationszwecken durchfuehren --------

	inc	ax		;Wert in AX um 1 erhoehen
	add	cx,cx		;Wert in CX verdoppeln
	
;-- Variablen mit den Registerwerten ueberschreiben ------------------------- 
;Wir wollen die manipulierten Variablen in BASIC nutzen. Alle uebergebenen 
;Variablen werden deshalb mit den aktuellen Registerwerten ueberschrieben. 
;In BASIC kann der neue Wert ausgelesen werden.

	mov	bx,[bp+8]       ;Speicheradresse des ersten Variable nach BX
	mov	[bx],ax		;erste Variable mit Wert aus AX ueberschreiben
	mov	bx,[bp+6]	;Speicheradresse der zweiten Variable nach BX
	mov	[bx],cx		;zweite Variable mit Wert aus CX ueberschreiben

;-- Alten Zustand von BP herstellen und zurueck zu BASIC --------------------

	pop     bp		;Stack-Basispointer auf alten Wert setzen
	retf    4		;2 Speicheradressen a 2 Byte vom Stack
				;freigeben und zurueck zu BASIC
